'programmed and compiled with: 
'JustBASIC 1.01 - http://www.justbasic.com

'special thanks to:
'tsh73 - Senior Member at the JustBASIC Conforums - 'http://justbasic.conforums.com

nomainwin

    count = 20
    dim array$(count)
    dim info$(1,1)

    gosub [getList]

    WindowWidth = 400
    WindowHeight = 390
    UpperLeftX = Int((DisplayWidth - WindowWidth)/2)
    UpperLeftY = Int((DisplayHeight - WindowHeight)/2)

    groupbox #main.groupbox1, "Utility Up To Run", 14, 10, 365, 110
    groupbox #main.groupbox2, "Utilities List", 14, 133, 365, 185

    textbox #main.textbox, 30, 35, 326, 25
    listbox #main.listbox, array$(), [List], 30, 158, 328, 140

    button #main.button1, "Run", [Run], UL, 30, 75, 218, 25
    button #main.button2, "Skip", [Skip], UL, 257, 75, 100, 25

    menu #main, "Menu", "Utility List Handler", [Handler], |, "About", [About]

    open "Utility Launcher" for window_nf as #main

    print #main, "font ms_sans_serif 0 12"
    print #main.textbox, array$(0)
    print #main.listbox, "singleclickselect"
    print #main.listbox, "selectindex 1"
    print #main, "trapclose [closeMain]"

    wait

[Run]

    #main.textbox, "!contents? program$"

    if program$ = "" then

        notice "No List" + chr$(13) + "Create A Utility List First."

    else

        print #main.button1, "!disable"

        run array$(iRun)

        timer 100, [continue.past]
        wait
        [continue.past]
        timer 0

        iRun = iRun + 1

        if array$(iRun) = "" or iRun >= count then iRun = 0

        print #main.textbox, array$(iRun)
        print #main.listbox, "selectindex "; iRun + 1

        print #main.button1, "!enable"

    end if

    wait

[Skip]

    iRun = iRun + 1

    if array$(iRun) = "" or iRun >= count then iRun = 0

    print #main.textbox, array$(iRun)
    print #main.listbox, "selectindex "; iRun + 1

    wait

[List]

    iList = 0

    print #main.listbox, "selection? selected$"

    do while iList < count

        if selected$ = array$(iList) then

            iRun = iList
            print #main.textbox, array$(iRun)
            exit do

        end if

        iList = iList + 1

    loop

    wait

[Handler]

    modify = 0

    gosub [getList]

    WindowWidth = 400
    WindowHeight = 390
    UpperLeftX = Int((DisplayWidth - WindowWidth)/2)
    UpperLeftY = Int((DisplayHeight - WindowHeight)/2)

    groupbox #build.groupbox, "Utility List", 14, 20, 365, 240
    listbox #build.listbox, array$(), [buildHandler], 32, 46, 328, 195

    bmpbutton #build.arrowup, "scrlup.bmp", [upClick], UL, 341, 291
    bmpbutton #build.arrowdn, "scrldown.bmp", [downClick], UL, 341, 313

    button #build.button1, "Add A Utility To List", [Add], UL, 30, 280, 140, 25
    button #build.button2, "Remove A Listed Utility", [Remove], UL, 30, 315, 140, 25
    button #build.button3, "Delete Current List", [Delete], UL, 180, 280, 140, 25
    button #build.button4, "Save Current List", [Save], UL, 180, 315, 140, 25

    open "Utility List Handler" for window_nf as #build

    print #build, "font ms_sans_serif 0 12"
    print #build.listbox, "singleclickselect"
    print #build, "trapclose [closeHandler]"

    wait

[upClick]

     gosub [clickHandler]

     if index>0 and array$(index) <> "" then

        tmp$ = array$(index)
        array$(index) = array$(index-1)
        array$(index-1) = tmp$
        #build.listbox, "reload"
        #build.listbox, "selectindex ";index

        iRemove = index - 1

     end if

     modify = 1

     wait


[downClick]

     gosub [clickHandler]

     if index<count and array$(index+1) <> "" then

        tmp$ = array$(index)
        array$(index) = array$(index+1)
        array$(index+1) = tmp$
        #build.listbox, "reload"
        #build.listbox, "selectindex ";index+2

        iRemove = index + 1

     end if

     modify = 1

     wait

[clickHandler]

    iClick = 0

    print #build.listbox, "selection? selected$"

    do while iClick < count

        if selected$ = array$(iClick) then

            index = iClick
            exit do

        end if

        iClick = iClick + 1

    loop

    return

    wait


[buildHandler]

    iHandler = 0

    print #build.listbox, "selection? selected$"

    do while iHandler < count

        if selected$ = array$(iHandler) then

            iRemove = iHandler
            exit do

        end if

        iHandler = iHandler + 1

    loop

    wait

[Add]

    iAdd = 0

    do while iAdd < count

        if array$(iAdd) = "" then

            filedialog "Navigate To Find The Utility You Want To Add To List", "C:\Program Files\*.exe",fileName$

            if fileName$ = "" then exit do

            array$(iAdd) = fileName$
            print #build.listbox, "reload"
            iRemove = iAdd
            modify = 1
            exit do

        end if

        iAdd = iAdd + 1

    loop

    if iAdd >= count then notice "Utility List Is Full. (";count;")   "

    wait

[Remove]

   print #build.listbox, "selection? selected$"

   if selected$ = "" then

   else

       do until array$(iRemove) = ""

           array$(iRemove) = array$(iRemove + 1)
           iRemove = iRemove + 1

       loop

       iRemove = 0
       modify = 1

       print #build.listbox, "reload"

    end if

    wait

[Delete]

    confirm "Do You Really Want To Delete The Entire Utility List?"; confirm$

    if confirm$ = "yes" then

        open DefaultDir$ + "\list.txt" for output as #1

            do while iDelete < count

                array$(iDelete) = ""
                print #1, array$(iDelete)
                iDelete = iDelete + 1

            loop

        close #1

        iDelete = 0
        modify = 0

        print #build.listbox, "reload"

        notice "Confirmed" + chr$(13) + "Entire List Should Be Gone..."

    end if

    wait

[Save]

    confirm "Do You Want To Save Current/Modified List?   ";confirm$

    if confirm$ = "yes" then

        gosub [saveList]

        modify = 0

    end if

    wait

[getList]

    iOpen = 0

    files DefaultDir$, "\list.txt", info$(
    if val(info$(0,0)) > 0 then

        open DefaultDir$ + "\list.txt" for input as #1

            do while iOpen < count

                input #1, array$(iOpen)
                iOpen = iOpen + 1

            loop

        close #1

    end if

    return

[saveList]

    iSave = 0

    open DefaultDir$ + "\list.txt" for output as #1

        do while iSave < count

            print #1, array$(iSave)
            iSave = iSave + 1

        loop

    close #1

    print #main.listbox, "reload"
    print #main.textbox, array$(0)
    print #main.listbox, "selectindex 1"

    notice "Confirmed" + chr$(13) + "New List Should Be Saved..."

    return

[About]

    WindowWidth = 205
    WindowHeight = 210
    UpperLeftX = 85
    UpperLeftY = 2

    statictext #about.statictext1, "Utility Launcher 2.0", 25, 10, 138, 20
    statictext #about.statictext2, "A Freeware Offering From", 35, 40, 144, 20
    statictext #about.statictext3, "James F. Bays", 38, 60, 104, 20
    statictext #about.statictext4, "Place up to 20 Utility Programs", 22, 90, 384, 20
    statictext #about.statictext5, "under a single (1) desktop icon.", 20, 110, 384, 20

    button #about.button, "Okay", [closeAbout], UL, 35, 140, 122, 25

    open "About" for dialog_modal as #about

    print #about, "font ms_sans_serif 0 10"
    print #about.statictext1, "!font ms_sans_serif 0 20"
    print #about.statictext3, "!font ms_sans_serif 0 20"
    print #about.button, "!font ms_sans_serif 0 12"
    print #about, "trapclose [closeAbout]"

    wait

[closeMain]

    close #main
    end

[closeHandler]

    if modify = 1 then

        confirm "Do You Want To Save Current/Modified List?   ";confirm$

        if confirm$ = "yes" then

            gosub [saveList]

        end if

    end if

    close #build

    wait

[closeAbout]

    close #about
    wait





